<?php
// $Id: menuicon.admin.inc,v 1.1 2008/11/30 21:46:06 pvb Exp $

function _menuicon_icon_edit($info = NULL, $mid = NULL, $path = TRUE) {

  $form = array();	
  if ($path) {
    $form['menuicon_path'] = array(
      '#type' => 'textfield',
      '#title'		=> t('Path'),
      '#default_value'	=> $info['path'],
      '#description'	=> t('Path menu for icon. For use a root it is necessary to specify "/"'),
      '#required'	=> TRUE, 
    );
  }
  $form['menuicon_path_original'] = array(
    '#type' => 'value',
    '#value' => $info['path'],
  );    
  $form['menuicon_name'] = array(
    '#type'	=> 'select',
    '#title' => t('Imageset'),
    '#default_value' => $info['name'],
    '#options' => array_merge(array('0'=> t('<Not use>')), imageset_names()),
  );
  $form['menuicon_index'] = array(
    '#type' => 'textfield',
    '#title' => t('Index'),
    '#default_value' => $info['index'],
    '#description'	=> t(''),
    '#size'		=> 4,
  );
  $form['menuicon_type'] = array(
    '#type' => 'select',
    '#title' => t('Type'),
    '#default_value' => $info['type'],
    '#description' => t(''),
    '#options' => menuicon_types(),
  );
  $form['menuicon_inherit'] = array(
    '#type' => 'checkbox',
    '#title' => t('Inherit'),
    '#default_value' => $info['inherit'],
    '#description' => t('To inherit for enclosed. For example the icon node/add will be used for all enclosed ways: node/add/page, node/add/news, node/add/*'),
  );
  if ($mid) {
    $form['menuicon_item'] = array(
      '#type' => 'item',
      '#title' => t('Sample'),
      '#value' => theme('menuicon_item' , $mid),
    );
  }
  return $form;
}

/**
 * Implementation of hook_form_alter(). 
Drupal5: function hook_form_alter($form_id, &$form) {
Drupal6: function hook_form_alter(&$form, $form_state, $form_id) { 
*/
function menuicon_form_alter(&$arg1, &$arg2, &$arg3 = NULL) {

  if (_pvb_form_alter_header($arg1, $arg2, $arg3, (_pvb_is_v6()? 'menu_edit_item': 'menu_edit_item_form'), $form)) {
    //print_r($form);
    if (_pvb_is_v6()) {
      $item = $form['menu']['original_item']['#value'];
      $mid =1;
    } 
    else {
      $mid = $form['mid']['#value'];
      $item = menu_get_item($mid);
      //echo "mid: $mid item: ";print_r($item);
    }
    //print_r($tem);
    $info = _menuicon_linkinfo($item['path'], FALSE);
    //print_r($info);
    $collapsed = !isset($info);
    $info['path'] = $item['path'];
    
    $menuicon = array_merge(
      array(
        '#type' => 'fieldset',
        '#title' => t('Menu icon'),
        '#collapsible' => TRUE,
        '#collapsed' => $collapsed,
      ),
      _menuicon_icon_edit($info, $mid, FALSE)
    );
    
    $result = array();
    foreach($form as $key => $value) {
      if ($key == 'submit') {
        $result['menuicon'] = $menuicon;
      }
      $result[$key] = $value;
    }
    $result['#submit'] = array_merge($result['#submit'], _pvb_form_func('menuicon_item_save_submit'));
    
    if (_pvb_is_v6()) $arg1 /* $form*/ = $result;
      else $arg2 /* $form*/ = $result;
  } 
/*  
  if (_pvb_form_alter_header($arg1, $arg2, $arg3, 'menu_overview_form', $form)) {
    _menuicon_menu_overview_form_alter($form);
  }
  */
}

function menuicon_item_save_submit($form_id, &$form_values) {

  $values = _pvb_form_value($form_values);
  $path = (_pvb_is_v6()? $values['menu']['original_item']['path'] : $values['menuicon_path_original']);
  $values['menuicon_path'] = (_pvb_is_v6()? $values['menu']['link_path']: $values['path']);
  menuicon_item_save($path, $values);
}

function menuicon_item_save($path, &$values) {

  $path = ($path && ($path != '<front>') ? $path : '/');
  if ($values['menuicon_name'] || $values['menuicon_inherit']) {
    $info = array();
    $info['newpath'] = drupal_get_normal_path($values['menuicon_path']);
    $info['newpath'] = ($info['newpath'] && ($info['newpath'] != '<front>') ? $info['newpath']: '/');
    $info['name'] = $values['menuicon_name'];
    $info['index'] = $values['menuicon_index'];
    $info['type'] = $values['menuicon_type'];
    $info['inherit'] = $values['menuicon_inherit'];
  
    _menuicon_linkinfo_update($path, $info);
  }
  else _menuicon_linkinfo_update($path); //delete
}

function menuicon_admin_settings() {

  $settings = variable_get('menuicon_settings', array());
  $form = array();
  $form['menuicon_settings'] = array(
    '#type' => 'fieldset',
    '#title' => 'Settings menuicon',
    '#tree' => TRUE,
    '#collapsible' => FALSE,
  );
  $override = _theme_menu_item_link_override(TRUE);
  $form['menuicon_settings']['std_menu_item_link'] = array(
    '#type'		=> 'checkbox',
    '#title'	=> t('Defined phptemplate_menu_item_link (Drupal 5 only)'),
    '#default_value'	=> ($settings['std_menu_item_link'] && $override),
    '#description' => t('Items of the standard menu will be themed (an opportunity to add an icons)'),
    '#disabled' => 	!$override,
  );
  if (!$override && !_pvb_is_v6()) {
    $form['menuicon_settings']['msg_menu_item_link'] = array(
      '#type'		=> 'item',
      '#value' => t('Now function phptemplate_menu_item_link is already redefined in your theme. To use there is no opportunity.'),
    );
  }
  return system_settings_form($form);
}

function menuicon_admin_settings_icons() {

  $settings = variable_get('menuicon_index', array());

  $header = array(t('Path'), t('Imagesets'),t('Inherit'), t('Icons'), t('Operation')  );
  $rows = array();
  foreach ($settings as $path => $value) {
    $menuicon_info = _menuicon_explodelink($value);
    $rows[] = array(
      check_plain($path),
      ($menuicon_info['name']? check_plain(sprintf('%s:%d', $menuicon_info['name'], $menuicon_info['index'])): "&nbsp;"),
      ($menuicon_info['inherit']? "yes" : "&nbsp;"),
      theme("imageset", $menuicon_info['name'], $menuicon_info['index']),
      _pvb_l(t('Edit'), PATH_IMAGESET_SETTINGS."/menuicon-icons/edit", array('query' => "key=$path") ),
    );
  }

  $form = array();
  $form['new'] = array_merge(
    array(
      '#type' => 'fieldset',
      '#title' => t('New menu icon'),
      '#collapsible' => TRUE,
      '#collapsed' => (count($rows) > 0),
    ), _menuicon_icon_edit()
  );
  $form['new']['submit'] = array('#type' => 'submit', '#value' => t('Save new menu icon') );
  $form['rows'] = array(
    '#type' => 'item',
    '#value' => (count($rows)? theme('table', $header, $rows): t('Not defined values')),
  );
	
  return $form;
}

function menuicon_admin_settings_icons_submit($form_id, $form_values) {

  $values = _pvb_form_value($form_values);
  $path = (isset($values['menuicon_path_original'])? $values['menuicon_path_original']: $values['menuicon_path']);
  menuicon_item_save($path, $values);
}

function menuicon_icon_edit() {

  $path = isset($_GET['key']) ? $_GET['key'] : '';
  $info = _menuicon_linkinfo($path, FALSE);
  if (!isset($info)) {
    drupal_set_message(t('Path "@path" not found', array('@path' => $path)));
    return;
  }
  $info['path'] = $path;
	
  $form = array();	
  $form['#redirect'] = PATH_IMAGESET_SETTINGS. '/menuicon-icons';
  $form['#submit'] = _pvb_form_func('menuicon_admin_settings_icons_submit');
  $form['edit'] = array_merge(
    array(
      '#type' => 'fieldset',
      '#title' => t('Menu icon'),
      '#collapsible' => FALSE,
    ),	
    _menuicon_icon_edit($info)
  );
  $form['edit']['submit'] = array('#type' => 'submit', '#value' => t('Save menu icon') );
  return $form;
}

function _menuicon_menu_overview_form_alter(&$form) {

  foreach($form as $key => $item) {
    if (is_array($item)) {
      //$path = $item['href'];
      $form[$key]['icon'] = array(
        'type' => '#item',
        'value' => theme_menuicon_item_link($item['#item']),
      );
    }
  }
}
